#include "mainwindow.h"

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
{
    menuBar = new QMenuBar();

    //3.2.1 File Menu
    fileMenu = new QMenu("&File");

    exitAction = new QAction("E&xit",fileMenu);
//  exitAction->setShortcut(QKeySequence::Quit);//original code from assignment. Ctrl+q is not supported on windows.
    exitAction->setShortcut(QKeySequence(tr("Ctrl+Q")));//workaround for windows.
    connect(exitAction , SIGNAL(triggered ( ) ) ,    this , SLOT(close ( ) ) ) ;

    fileMenu->addAction(exitAction );
    menuBar->addMenu(fileMenu );


    //3.2.2 Shading Menu
    shadingMenu = new QMenu("Shading");

    shadeNoneAction = new QAction("None",shadingMenu);
    shadeFlatAction = new QAction("Flat",shadingMenu);
    shadeGouraudAction = new QAction("Gouraud",shadingMenu);
    shadePhongAction = new QAction("Phong",shadingMenu);

    shadeNoneAction->setShortcut(QKeySequence(tr("Ctrl+1")));
    shadeFlatAction->setShortcut(QKeySequence(tr("Ctrl+2")));
    shadeGouraudAction->setShortcut(QKeySequence(tr("Ctrl+3")));
    shadePhongAction->setShortcut(QKeySequence(tr("Ctrl+4")));

    shadeNoneAction->setCheckable(true);
    shadeFlatAction->setCheckable(true);
    shadeGouraudAction->setCheckable(true);
    shadePhongAction->setCheckable(true);

    shadeNoneAction->setIcon(QIcon(":/img/wireframe.png"));
    shadeFlatAction->setIcon(QIcon(":/img/flat.png"));
    shadeGouraudAction->setIcon(QIcon(":/img/gouraud.png"));
    shadePhongAction->setIcon(QIcon(":/img/phong.png"));

    shaderGroup = new QActionGroup(shadingMenu);
    shaderGroup->addAction(shadeNoneAction);
    shaderGroup->addAction(shadeFlatAction);
    shaderGroup->addAction(shadeGouraudAction);
    shaderGroup->addAction(shadePhongAction);

    shadingMenu->addAction(shadeNoneAction);
    shadingMenu->addAction(shadeFlatAction);
    shadingMenu->addAction(shadeGouraudAction);
    shadingMenu->addAction(shadePhongAction);

    shadeFlatAction->setChecked(true);

    menuBar->addMenu(shadingMenu);


    //3.2.3 About Message Box
    aboutAction = new QAction("About",menuBar);
    connect(aboutAction, SIGNAL(triggered()), this,SLOT(showAboutBox()));
    menuBar->addAction(aboutAction);

    //3.3 Toolbar
    toolBar = new QToolBar("ToolBar",this);
    toolBar->addAction(shadeNoneAction);
    toolBar->addAction(shadeFlatAction);
    toolBar->addAction(shadeGouraudAction);
    toolBar->addAction(shadePhongAction);
    addToolBar( toolBar);

    //3.4 Status Bar
    statusBar = new QStatusBar(this);
    statusBar->showMessage("test status message");
    setStatusBar(statusBar);

    setMenuBar(menuBar);
}

MainWindow::~MainWindow()
{

}

void MainWindow::showAboutBox(){
    QMessageBox msgBox;
    msgBox.setWindowTitle("About Hello Cube!");
    msgBox.setText("Written by Alisa");
    msgBox.exec();
}
